﻿Imports System.Data
Imports System.Data.SqlClient
Class Clients

    Private primeraCarga As Boolean = True
    Private Sub Clients_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        If primeraCarga Then
            MostrarClients("")
            txtId.Focus()
            primeraCarga = False
        End If

    End Sub

#Region "Mostrar Dades"

    Private Sub MostrarClients(ByVal filtro As String)

        Try
            Dim l As ServeiChiquiPark.Client()
            l = Configuracio.Instance.Servei.GetClients(filtro)
            lvClientes.DataContext = l

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try


    End Sub
    Private Sub MostrarClient(ByVal id As Long)

        Try
            Dim c As ServeiChiquiPark.Client
            c = Configuracio.Instance.Servei.GetClient(id)
            If c IsNot Nothing Then OmplirTextBox(c)

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub lvClientes_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles lvClientes.SelectionChanged

        If lvClientes.SelectedItem IsNot Nothing Then OmplirTextBox(lvClientes.SelectedItem)

    End Sub
    Private Sub OmplirTextBox(ByVal cli As ServeiChiquiPark.Client)

        txtId.Text = cli.Id
        txtNom.Text = cli.Nom
        txtCognoms.Text = cli.Cognoms
        txtDireccio.Text = cli.Direccio
        txtPoblacio.Text = cli.Poblacio
        txtEmail.Text = cli.Email
        txtLogin.Text = cli.Login
        txtPassword.Text = cli.Password

    End Sub
    Private Sub ResetTextBox()

        txtId.Text = ""
        txtNom.Text = ""
        txtCognoms.Text = ""
        txtDireccio.Text = ""
        txtPoblacio.Text = ""
        txtEmail.Text = ""
        txtLogin.Text = ""
        txtPassword.Text = ""

        lvClientes.SelectedIndex = -1

        txtId.Focus()

    End Sub

#End Region

#Region "Validació"

    Private Sub txtId_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles txtId.KeyDown, txtNom.KeyDown, txtCognoms.KeyDown, txtDireccio.KeyDown, _
                                                                                                       txtPoblacio.KeyDown, txtEmail.KeyDown, txtLogin.KeyDown, txtPassword.KeyDown, _
                                                                                                      txtFiltro.KeyDown
        If e.Key = Key.Enter Then
            Select Case sender.Name
                Case txtFiltro.Name : MostrarClients(txtFiltro.Text)
                Case Else
                    sender.MoveFocus(New TraversalRequest(FocusNavigationDirection.Next))
            End Select
        End If

    End Sub
    Private Sub txtId_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles txtId.LostFocus

        If txtId.Text <> "" Then
            Dim id As Long
            If Not Long.TryParse(txtId.Text, id) Then id = -1
            If id > 0 Then
                MostrarClient(id)
            Else
                txtId.Text = ""
            End If
        End If

    End Sub

#End Region

#Region "Manteniment Dades"

    Private Sub btnGravar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnGravar.Click

        Dim id As Long
        If Not Long.TryParse(txtId.Text, id) OrElse id <= 0 Then id = -1

        Cursor = Cursors.Wait

        Dim cli As New ServeiChiquiPark.Client

        cli.Id = id
        cli.Nom = txtNom.Text
        cli.Cognoms = txtCognoms.Text
        cli.Direccio = txtDireccio.Text
        cli.Poblacio = txtPoblacio.Text
        cli.Email = txtEmail.Text
        cli.Login = txtLogin.Text
        cli.Password = txtPassword.Text

        Try
            Dim resultat As Byte = Configuracio.Instance.Servei.SetClient(cli)
            Select Case resultat
                Case 0 : MsgBox("Error al guardar el client !", MsgBoxStyle.Exclamation)
                Case 1
                    MostrarClients(txtFiltro.Text)
                    ResetTextBox()
                Case 2 : MsgBox("Error el login ja està assignat a un altre client !", MsgBoxStyle.Exclamation)
            End Select
        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

        Cursor = Cursors.Arrow

    End Sub
    Private Sub btnNou_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnNou.Click

        ResetTextBox()

    End Sub
    Private Sub btnTancar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnTancar.Click

        If Me.Parent IsNot Nothing Then CType(Me.Parent, DockPanel).Visibility = Windows.Visibility.Collapsed

    End Sub
    Private Sub btnEliminar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnEliminar.Click

        If txtId.Text <> "" AndAlso MsgBox("Vol esborrar el client ? ", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Dim lng As Long
            If Not Long.TryParse(txtId.Text, lng) Then lng = 0
            If lng > 0 Then
                Try
                    Dim res As Byte = Configuracio.Instance.Servei.DeleteClient(lng)
                    Select Case res
                        Case 0 : MsgBox("Error al eliminar el client !", MsgBoxStyle.Exclamation)
                        Case 1
                            ResetTextBox()
                            MostrarClients(txtFiltro.Text)
                        Case 2 : MsgBox("Error el client està assignat a reserves/tickets !", MsgBoxStyle.Exclamation)
                    End Select
                Catch ex As Exception
                    MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
                End Try
            End If
        End If

    End Sub

#End Region

End Class
