﻿Public Class LiniaTicket

    Private primeraCarga As Boolean = True
    Public liniaTicket As ServeiChiquiPark.LiniaTicket
    Public Acceptat As Boolean = False
    Private Sub LiniaTicket_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        If primeraCarga Then

            txtNom.Text = liniaTicket.Article.Nom

            Try
                Dim path As BitmapImage = New BitmapImage()
                path.BeginInit()
                path.UriSource = New Uri(liniaTicket.Article.Imatge)
                path.EndInit()
                Imatge.Source = path
            Catch ex As Exception

            End Try

            If liniaTicket.Article.Tipus Then
                lblArticle.Content = "Activitat :"
                lblQuantitat.Content = "Num. nens :"
            Else
                lblArticle.Content = "Article :"
                lblQuantitat.Content = "Quantitat :"
                lblTemps.Visibility = Windows.Visibility.Collapsed
                txtTemps.Visibility = Windows.Visibility.Collapsed
            End If

            MostrarLinia()
            MostrarPromocions()

            primeraCarga = False
        End If

    End Sub
    Private Sub btnOk_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnOk.Click
        Acceptat = True
        Close()
    End Sub
    Private Sub btnCancelar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnCancelar.Click
        Close()
    End Sub

#Region "Mostrar Dades"

    Private Sub MostrarLinia()

        If liniaTicket Is Nothing Then Return

        txtQuantitat.Text = Integer.Parse(liniaTicket.Quantitat).ToString
        txtPreu.Text = Math.Round(liniaTicket.Preu, 2, MidpointRounding.ToEven)
        txtTemps.Text = Math.Round(liniaTicket.Temps, 2, MidpointRounding.ToEven)

    End Sub
    Private Sub MostrarPromocions()

        Try
            Dim l As ServeiChiquiPark.Promocio()
            l = Configuracio.Instance.Servei.GetArticlePromocions(liniaTicket.Article.Id, "")
            lvPromocions.DataContext = l

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub lvPromocions_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles lvPromocions.SelectionChanged

        If lvPromocions.SelectedItem IsNot Nothing Then

            Dim pro As ServeiChiquiPark.Promocio = lvPromocions.SelectedItem
            liniaTicket.Quantitat = pro.Quantitat
            liniaTicket.Preu = pro.Preu
            liniaTicket.Temps = pro.Temps

            MostrarLinia()
        End If
        lvPromocions.SelectedIndex = -1

    End Sub

#End Region

#Region "Validació"

    Private Sub txt_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles txtQuantitat.KeyDown, txtPreu.KeyDown, txtTemps.KeyDown

        If e.Key = Key.Enter Then
            Select Case sender.Name
                Case txtQuantitat.Name
                    sender.MoveFocus(New TraversalRequest(FocusNavigationDirection.Next))
                Case txtPreu.Name
                    If txtTemps.Visibility = Windows.Visibility.Visible Then
                        sender.MoveFocus(New TraversalRequest(FocusNavigationDirection.Next))
                    End If
            End Select
        End If

    End Sub
    Private Sub txt_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles txtQuantitat.LostFocus, txtPreu.LostFocus, txtTemps.LostFocus

        Select Case sender.Name

            Case txtQuantitat.Name
                Dim quant As Integer
                If Not Integer.TryParse(txtQuantitat.Text, quant) Then quant = 0
                txtQuantitat.Text = quant.ToString
                liniaTicket.Quantitat = quant
            Case txtPreu.Name
                Dim preu As Double
                If Not Double.TryParse(txtPreu.Text.Replace(".", ","), preu) Then preu = 0
                txtPreu.Text = Format(preu, "#.##")
                liniaTicket.Preu = preu
            Case txtTemps.Name
                Dim temps As Double
                If Not Double.TryParse(txtTemps.Text.Replace(".", ","), temps) Then temps = 0
                txtTemps.Text = Format(temps, "#.##")
                liniaTicket.Temps = temps
        End Select

    End Sub

#End Region

End Class
