﻿Public Class Promocions

    Private primeraCarga As Boolean = True
    Private Sub Promocions_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        If primeraCarga Then
            MostrarPromocions("")
            txtId.Focus()
            primeraCarga = False
        End If

    End Sub

#Region "Mostrar Dades"

    Private Sub MostrarPromocions(ByVal filtro As String)

        Try
            Dim l As ServeiChiquiPark.Promocio()
            l = Configuracio.Instance.Servei.GetPromocions(filtro)
            lvPromocions.DataContext = l

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try


    End Sub
    Private Sub MostrarPromocio(ByVal id As Long)

        Try
            Dim p As ServeiChiquiPark.Promocio
            p = Configuracio.Instance.Servei.GetPromocio(id)
            If p IsNot Nothing Then OmplirTextBox(p)

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub MostrarArticle(ByVal id As Long)

        Try
            Dim a As ServeiChiquiPark.Article
            a = Configuracio.Instance.Servei.GetArticle(id)
            If a IsNot Nothing Then
                txtIdArticle.Text = a.Id.ToString
                txtNomArticle.Text = a.Nom
            End If

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub OmplirTextBox(ByVal pro As ServeiChiquiPark.Promocio)

        txtId.Text = pro.Id
        txtNom.Text = pro.Nom
        txtDescripcio.Text = pro.Descripcio
        txtQuantitat.Text = pro.Quantitat.ToString
        txtPreu.Text = pro.Preu.ToString
        txtTemps.Text = pro.Temps.ToString

        txtIdArticle.Text = pro.Article.Id
        txtNomArticle.Text = pro.Article.Nom

    End Sub
    Private Sub ResetTextBox()

        txtId.Text = ""
        txtNom.Text = ""
        txtDescripcio.Text = ""
        txtQuantitat.Text = ""
        txtPreu.Text = ""
        txtTemps.Text = ""

        txtIdArticle.Text = ""
        txtNomArticle.Text = ""

        lvPromocions.SelectedIndex = -1

        txtId.Focus()

    End Sub
    Private Sub lvPromocions_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles lvPromocions.SelectionChanged

        If lvPromocions.SelectedItem IsNot Nothing Then OmplirTextBox(lvPromocions.SelectedItem)

    End Sub

#End Region

#Region "Validació"

    Private Sub txtId_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles txtId.KeyDown, txtNom.KeyDown, txtIdArticle.KeyDown, txtQuantitat.KeyDown, _
                                                                                                            txtPreu.KeyDown, txtTemps.KeyDown, txtFiltro.KeyDown

        If e.Key = Key.Enter Then
            Select Case sender.Name
                Case txtFiltro.Name : MostrarPromocions(txtFiltro.Text)
                Case Else : sender.MoveFocus(New TraversalRequest(FocusNavigationDirection.Next))
            End Select
        End If

    End Sub
    Private Sub txtId_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles txtId.LostFocus, txtQuantitat.LostFocus, txtIdArticle.LostFocus, _
                                                                                                           txtPreu.LostFocus, txtTemps.LostFocus
        Select Case sender.Name
            Case txtId.Name
                Dim id As Long
                If Not Long.TryParse(txtId.Text, id) Then id = -1
                If id > 0 Then
                    MostrarPromocio(id)
                Else
                    txtId.Text = ""
                End If
            Case txtIdArticle.Name
                Dim id As Long
                If Not Long.TryParse(txtIdArticle.Text, id) Then id = -1
                If id > 0 Then
                    MostrarArticle(id)
                Else
                    txtIdArticle.Text = ""
                    txtNomArticle.Text = ""
                End If
            Case txtQuantitat.Name, txtPreu.Name, txtTemps.Name
                Dim db As Double
                If Not Double.TryParse(sender.Text.Replace(".", ","), db) Then db = 0
                sender.Text = Format(db, "#.##")
        End Select

    End Sub

#End Region

#Region "Manteniment Dades"

    Private Sub btnGravar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnGravar.Click

        Dim id As Long
        If Not Long.TryParse(txtId.Text, id) OrElse id <= 0 Then id = -1

        Dim idArt As Long
        If Not Long.TryParse(txtIdArticle.Text, idArt) OrElse idArt <= 0 Then idArt = -1

        If idArt = -1 Then
            MsgBox("Cal assignar un article !", MsgBoxStyle.Exclamation)
            Return
        End If
        Cursor = Cursors.Wait

        Dim pro As New ServeiChiquiPark.Promocio

        pro.Id = id
        pro.Nom = txtNom.Text
        pro.Descripcio = txtDescripcio.Text
        If Not Double.TryParse(txtQuantitat.Text, pro.Quantitat) Then pro.Quantitat = 0.0
        If Not Double.TryParse(txtPreu.Text, pro.Preu) Then pro.Preu = 0.0
        If Not Double.TryParse(txtTemps.Text, pro.Temps) Then pro.Temps = 0.0

        Try
            pro.Article = Configuracio.Instance.Servei.GetArticle(idArt)
            If Configuracio.Instance.Servei.SetPromocio(pro) Then
                MostrarPromocions(txtFiltro.Text)
                ResetTextBox()
            Else
                MsgBox("Error al guardar la promoció !", MsgBoxStyle.Exclamation)
            End If

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

        Cursor = Cursors.Arrow

    End Sub
    Private Sub btnNou_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnNou.Click

        ResetTextBox()

    End Sub
    Private Sub btnTancar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnTancar.Click

        If Me.Parent IsNot Nothing Then CType(Me.Parent, DockPanel).Visibility = Windows.Visibility.Collapsed

    End Sub
    Private Sub btnEliminar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnEliminar.Click

        If txtId.Text <> "" AndAlso MsgBox("Vol esborrar la promoció ? ", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Dim lng As Long
            If Not Long.TryParse(txtId.Text, lng) Then lng = 0
            If lng > 0 Then
                Dim res As Byte = Configuracio.Instance.Servei.DeletePromocio(lng)
                Select Case res
                    Case 0 : MsgBox("Error al eliminar la promoció !", MsgBoxStyle.Exclamation)
                    Case 1
                        ResetTextBox()
                        MostrarPromocions(txtFiltro.Text)
                End Select
            End If
        End If

    End Sub

#End Region
   
    

End Class
