﻿Public Class Reserves
    Private primeraCarga As Boolean = True
    Private IdSeleccionat As Integer = -1
    Private client As ServeiChiquiPark.Client
    Private Sub Reserves_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        If primeraCarga Then
            MostrarArticles("")
            MostrarReserves("")
            txtId.Focus()
            primeraCarga = False
        End If

    End Sub

#Region "Mostrar Dades"

    Private Sub MostrarArticles(ByVal filtro As String)

        Try
            Dim l As ServeiChiquiPark.Article()
            l = Configuracio.Instance.Servei.GetTipusArticles(True, filtro)
            cmbActivitats.DataContext = l
            If l.Count > 0 Then cmbActivitats.SelectedIndex = 0

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try


    End Sub
    Private Sub MostrarReserves(ByVal filtro As String)

        Try
            Dim l As ServeiChiquiPark.Reserva()
            l = Configuracio.Instance.Servei.GetReserves(filtro)
            lvReserves.DataContext = l

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try


    End Sub
    Private Sub MostrarReserva(id As Long)
        Try
            Dim r As ServeiChiquiPark.Reserva
            r = Configuracio.Instance.Servei.GetReserva(id)
            If r IsNot Nothing Then OmplirTextBox(r)

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub MostrarClient(id As Long)
        Try
            Dim c As ServeiChiquiPark.Client
            c = Configuracio.Instance.Servei.GetClient(id)
            If c IsNot Nothing Then
                txtNomClient.Text = c.Nom
                client = c
            Else
                txtNomClient.Text = ""
                client = Nothing
            End If

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub OmplirTextBox(ByVal res As ServeiChiquiPark.Reserva)

        For Each art As ServeiChiquiPark.Article In cmbActivitats.ItemsSource
            If art.Id = res.Article.Id Then
                cmbActivitats.SelectedItem = art
            End If
        Next
        txtId.Text = res.Id.ToString
        txtIdClient.Text = res.Client.Id.ToString
        client = res.Client
        txtNomClient.Text = res.Client.Nom
        txtData.Text = res.DataText
        txtNens.Text = res.Nens.ToString
        MostrarHores(res.DataReserva)

    End Sub
    Private Sub lvReserves_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles lvReserves.SelectionChanged

        If lvReserves.SelectedItem IsNot Nothing Then OmplirTextBox(lvReserves.SelectedItem)

    End Sub
    Private Sub MostrarHores(data As Date)

        cmbHores.ItemsSource = Configuracio.Instance.Servei.GetDiaReserves(data, 1)

        If cmbHores.ItemsSource IsNot Nothing Then
            If lvReserves.SelectedItem IsNot Nothing Then
                For Each res As ServeiChiquiPark.Reserva In cmbHores.ItemsSource
                    If CType(lvReserves.SelectedItem, ServeiChiquiPark.Reserva).DataReserva.Hour = res.DataReserva.Hour Then
                        cmbHores.SelectedItem = res
                        Exit For
                    End If
                Next
            Else : cmbHores.SelectedIndex = 0
            End If
        End If

    End Sub
    Private Sub ResetTextBoxes()

        txtId.Text = ""
        txtIdClient.Text = ""
        client = Nothing
        txtNomClient.Text = ""
        cmbActivitats.SelectedIndex = 0
        txtData.Text = ""
        cmbHores.ItemsSource = Nothing
        txtNens.Text = ""
        IdSeleccionat = -1
        lvReserves.SelectedIndex = -1

        txtId.Focus()

    End Sub
    Private Sub lvReserves_MouseLeftButtonUp(sender As Object, e As System.Windows.Input.MouseButtonEventArgs) Handles lvReserves.MouseLeftButtonUp

        Dim dep As DependencyObject = e.OriginalSource

        While (dep IsNot Nothing AndAlso Not TypeOf dep Is ListViewItem)
            dep = VisualTreeHelper.GetParent(dep)
        End While

        If dep Is Nothing Then Return

        Dim res As ServeiChiquiPark.Reserva = lvReserves.ItemContainerGenerator.ItemFromContainer(dep)

        If res Is Nothing Then Return

        If res.Id = IdSeleccionat Then
            ResetTextBoxes()
        Else
            For Each art As ServeiChiquiPark.Article In cmbActivitats.ItemsSource
                If art.Id = res.Article.Id Then
                    cmbActivitats.SelectedItem = art
                End If
            Next
            txtId.Text = res.Id.ToString
            txtIdClient.Text = res.Client.Id.ToString
            txtNomClient.Text = res.Client.Nom
            txtData.Text = res.DataText
            txtNens.Text = res.Nens.ToString
            MostrarHores(res.DataReserva)
            IdSeleccionat = res.Id
        End If

    End Sub

#End Region

#Region "Validació"

    Private Sub txtId_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles txtId.KeyDown, txtIdClient.KeyDown, txtData.KeyDown, _
                                                                                                          txtNens.KeyDown, txtFiltro.KeyDown
        If e.Key = Key.Enter Then
            Select Case sender.Name
                Case txtId.Name : txtIdClient.Focus()
                Case txtIdClient.Name : txtData.Focus()
                Case txtData.Name : txtNens.Focus()
                Case txtNens.Name : txtFiltro.Focus()
                Case txtFiltro.Name : MostrarReserves(txtFiltro.Text)
            End Select
        End If

    End Sub
    Private Sub txtId_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles txtId.LostFocus, txtIdClient.LostFocus, txtData.LostFocus, txtNens.LostFocus

        Select Case sender.Name
            Case txtId.Name
                If txtId.Text <> "" Then
                    Dim id As Long
                    If Not Long.TryParse(txtId.Text, id) Then id = -1
                    If id > 0 Then
                        MostrarReserva(id)
                    Else
                        txtId.Text = ""
                    End If
                End If
            Case txtIdClient.Name
                If txtIdClient.Text <> "" Then
                    Dim id As Long
                    If Not Long.TryParse(txtIdClient.Text, id) Then id = -1
                    If id > 0 Then
                        MostrarClient(id)
                    Else
                        txtIdClient.Text = ""
                        txtNomClient.Text = ""
                        client = Nothing
                    End If
                End If
            Case txtData.Name
                If txtData.Text <> "" Then
                    Dim dt As Date
                    If Not Date.TryParse(txtData.Text, dt) Then dt = Date.MinValue
                    If dt <> Date.MinValue Then
                        txtData.Text = dt.ToString("dd/MM/yyyy")
                        MostrarHores(dt)
                    Else
                        txtData.Text = ""
                    End If
                End If
            Case txtNens.Name
                If txtNens.Text <> "" Then
                    Dim bt As Byte
                    If Not Byte.TryParse(txtNens.Text, bt) Then bt = 1
                    txtNens.Text = bt.ToString

                End If
        End Select

    End Sub

#End Region

#Region "Calendari"

    Private Sub btnCalendari_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnCalendari.Click

        calendari.Visibility = Windows.Visibility.Visible

    End Sub
    Private Sub calendari_SelectedDatesChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles calendari.SelectedDatesChanged

        If calendari.SelectedDate IsNot Nothing Then
            Dim dt As Date = calendari.SelectedDate
            txtData.Text = dt.ToString("dd/MM/yyyy")
            calendari.Visibility = Windows.Visibility.Collapsed
            MostrarHores(dt)
        End If

    End Sub

#End Region

#Region "Manteniment Dades"

    Private Sub btnGravar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnGravar.Click

        If client Is Nothing Then
            MsgBox("Falta introduir el client !")
            Return
        End If
        Dim res As New ServeiChiquiPark.Reserva

        If cmbHores.SelectedItem IsNot Nothing Then
            res.DataReserva = CType(cmbHores.SelectedItem, ServeiChiquiPark.Reserva).DataReserva
        Else : res.DataReserva = Date.MinValue
        End If
        Dim bt As Byte
        If Not Byte.TryParse(txtNens.Text, bt) Then bt = 0
        res.Nens = bt
        res.Client = client
        res.Article = cmbActivitats.SelectedItem

        If lvReserves.SelectedIndex > -1 Then
            res.Id = CType(lvReserves.SelectedItem, ServeiChiquiPark.Reserva).Id
        Else
            res.Id = -1
        End If

        If res.DataReserva <> Date.MinValue AndAlso bt > 0 Then

            Try
                If Configuracio.Instance.Servei.SetReserva(res) Then
                    ResetTextBoxes()
                    MostrarReserves(txtFiltro.Text)
                Else
                    MsgBox("Error al guardar la reserva !", MsgBoxStyle.Exclamation)
                End If

            Catch ex As Exception
                MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
            End Try
        Else : MsgBox("Calen introduir tots els camps !", MsgBoxStyle.Exclamation)
        End If

    End Sub
    Private Sub btnNou_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnNou.Click

        ResetTextBoxes()

    End Sub
    Private Sub btnTancar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnTancar.Click

        If Me.Parent IsNot Nothing Then CType(Me.Parent, DockPanel).Visibility = Windows.Visibility.Collapsed

    End Sub
    Private Sub btnEliminar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnEliminar.Click

        If txtId.Text <> "" AndAlso MsgBox("Vol esborrar la reserva ? ", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Dim lng As Long
            If Not Long.TryParse(txtId.Text, lng) Then lng = 0
            If lng > 0 Then
                Try
                    If Configuracio.Instance.Servei.DeleteReserva(lng) Then
                        ResetTextBoxes()
                        MostrarReserves(txtFiltro.Text)
                    Else : MsgBox("Error al eliminar la reserva !", MsgBoxStyle.Exclamation)
                    End If
                Catch ex As Exception
                    MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
                End Try
            End If
        End If

    End Sub

#End Region
    
    
   
    
End Class
