﻿Imports System.Data
Imports System.Data.SqlClient
Class Tickets

    Private primeraCarga As Boolean = True
    Private listaLinies As New List(Of ServeiChiquiPark.LiniaTicket)
    Private tic As New ServeiChiquiPark.Ticket

    Private Sub Tickets_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        If primeraCarga Then
            cmbTipo.Items.Add("Artículo")
            cmbTipo.Items.Add("Actividad")
            cmbTipo.SelectedIndex = 0
            MostrarArticles(0, "")
            lvTicket.ItemsSource = listaLinies
            txtId.Focus()
            primeraCarga = False
        End If

    End Sub

#Region "Mostrar Dades"

    Private Sub MostrarArticles(ByVal tipo As Boolean, ByVal filtro As String)

        Try
            Dim l As ServeiChiquiPark.Article()
            l = Configuracio.Instance.Servei.GetTipusArticles(tipo, filtro)
            lbArticles.DataContext = l

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try


    End Sub
    Private Sub MostrarTicket(ByVal id As Long)

        Try
            tic = Configuracio.Instance.Servei.GetTicket(id)
            If tic IsNot Nothing Then
                OmplirTextBox()
            Else
                ResetTextBox(False)
            End If


        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub MostrarClient(ByVal id As Long)

        Try

            tic.Client = Configuracio.Instance.Servei.GetClient(id)
            If tic.Client IsNot Nothing Then
                txtIdClient.Text = tic.Client.Id.ToString
                txtNomClient.Text = tic.Client.Nom
            Else
                txtIdClient.Text = ""
                txtNomClient.Text = ""
            End If

        Catch ex As Exception
            MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
        End Try

    End Sub
    Private Sub OmplirTextBox()

        txtId.Text = tic.Id
        txtIdClient.Text = tic.Client.Id.ToString
        txtNomClient.Text = tic.Client.Nom
        txtData.Text = tic.DataTicket.ToString("dd/MM/yyyy")

        txtBase.Text = tic.BaseImponible.ToString("f2")
        txtIva.Text = tic.Iva.ToString("f2")
        txtTotal.Text = tic.Total.ToString("f2")

        Dim ltic As New ServeiChiquiPark.LiniaTicket
        For Each linia As ServeiChiquiPark.LiniaTicket In tic.Linies
            ltic = New ServeiChiquiPark.LiniaTicket
            ltic.Id = linia.Id
            ltic.Preu = linia.Preu
            ltic.Quantitat = linia.Quantitat
            ltic.Temps = linia.Temps
            ltic.Article = New ServeiChiquiPark.Article
            ltic.Article.Id = linia.Article.Id
            ltic.Article.Nom = linia.Article.Nom
            ltic.Article.Preu = linia.Article.Preu
            ltic.Article.Imatge = linia.Article.Imatge
            ltic.Article.Tipus = linia.Article.Tipus
            listaLinies.Add(ltic)
        Next
        CollectionViewSource.GetDefaultView(lvTicket.ItemsSource).Refresh()

    End Sub
    Private Sub ResetTextBox(Optional ByVal enfocarId As Boolean = True)

        tic = New ServeiChiquiPark.Ticket

        txtId.Text = ""
        txtIdClient.Text = ""
        txtNomClient.Text = ""
        txtData.Text = ""
        txtBase.Text = ""
        txtIva.Text = ""
        txtTotal.Text = ""

        lbArticles.SelectedIndex = -1
        listaLinies.Clear()
        CollectionViewSource.GetDefaultView(lvTicket.ItemsSource).Refresh()

        If enfocarId Then txtId.Focus()

    End Sub
    Private Sub lvTicket_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles lvTicket.SelectionChanged

        If lvTicket.SelectedItem IsNot Nothing Then EliminarLinia(lvTicket.SelectedItem)
        lvTicket.SelectedIndex = -1

    End Sub
    Private Sub lbArticles_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles lbArticles.SelectionChanged

        If lbArticles.SelectedItem IsNot Nothing Then IntroduirLinia(lbArticles.SelectedItem)
        lbArticles.SelectedIndex = -1

    End Sub
    Private Sub cmbTipo_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles cmbTipo.SelectionChanged

        If cmbTipo.SelectedItem IsNot Nothing Then MostrarArticles(cmbTipo.SelectedIndex, txtFiltro.Text)

    End Sub

#End Region

#Region "Validació"

    Private Sub txtId_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles txtId.KeyDown, txtIdClient.KeyDown, txtData.KeyDown, txtFiltro.KeyDown

        If e.Key = Key.Enter Then
            Select Case sender.Name
                Case txtFiltro.Name : MostrarArticles(cmbTipo.SelectedIndex, txtFiltro.Text)
                Case Else : sender.MoveFocus(New TraversalRequest(FocusNavigationDirection.Next))
            End Select
        End If

    End Sub
    Private Sub txt_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles txtId.LostFocus, txtIdClient.LostFocus, txtData.LostFocus

        Select Case sender.Name

            Case txtId.Name
                Dim id As Long
                If Not Long.TryParse(txtId.Text, id) Then id = -1
                If id > 0 Then
                    MostrarTicket(id)
                Else
                    tic.Id = -1
                    txtId.Text = ""
                End If
            Case txtIdClient.Name
                Dim id As Long
                If Not Long.TryParse(txtIdClient.Text, id) Then id = -1
                If id > 0 Then
                    MostrarClient(id)
                Else
                    txtIdClient.Text = ""
                    txtNomClient.Text = ""
                End If
            Case txtData.Name
                Dim dt As Date
                If Not Date.TryParse(txtData.Text, dt) Then dt = Today
                txtData.Text = dt.ToString("dd/MM/yyyy")
                tic.DataTicket = dt
        End Select

    End Sub
    Private Sub CalculaTotals()

        Dim base As Double = 0

        For Each linia As ServeiChiquiPark.LiniaTicket In listaLinies
            If linia.Article.Tipus Then
                base += (linia.Preu * linia.Quantitat * linia.Preu)
            Else : base += (linia.Preu * linia.Quantitat)
            End If

        Next

        If base <> 0 Then
            Dim iva As Double = 0
            Dim total As Double = 0
            iva = base * 0.18
            total = base + iva
            txtBase.Text = Math.Round(base, 2).ToString
            tic.BaseImponible = base
            txtIva.Text = Math.Round(iva, 2).ToString
            tic.Iva = iva
            txtTotal.Text = Math.Round(total, 2).ToString
            tic.Total = total
        Else
            txtBase.Text = ""
            txtIva.Text = ""
            txtTotal.Text = ""
        End If

    End Sub

#End Region

#Region "Manteniment Dades"

    Private Sub EliminarLinia(ByVal ltic As ServeiChiquiPark.LiniaTicket)

        Dim lticAux As ServeiChiquiPark.LiniaTicket
        Dim trobat As Integer = -1
        For i As Integer = 0 To listaLinies.Count - 1
            lticAux = listaLinies(i)
            If lticAux.Id = ltic.Id Then
                trobat = i
                listaLinies.RemoveAt(i)
                Exit For
            End If
        Next
        If trobat > -1 Then
            For i As Integer = trobat To listaLinies.Count - 1
                lticAux = listaLinies(i)
                lticAux.Id -= 1
            Next
            CollectionViewSource.GetDefaultView(lvTicket.ItemsSource).Refresh()
            CalculaTotals()
        End If
    End Sub
    Private Sub IntroduirLinia(ByVal art As ServeiChiquiPark.Article)

        Dim trobat As Boolean = False
        Dim ltic As ServeiChiquiPark.LiniaTicket = Nothing
        For Each ltic In listaLinies
            If ltic.Article.Id = art.Id Then
                trobat = True
                Exit For
            End If
        Next
        If Not trobat Then
            ltic = New ServeiChiquiPark.LiniaTicket

            ltic.Id = listaLinies.Count + 1
            ltic.Article = art
            ltic.Preu = art.Preu
            ltic.Quantitat = 1.0
            If ltic.Article.Tipus Then
                ltic.Temps = 1.0
            Else : ltic.Temps = 0.0
            End If

        End If

        If ltic IsNot Nothing Then

            Dim w As New LiniaTicket
            w.liniaTicket = ltic
            w.ShowDialog()

            If w.Acceptat Then
                If Not trobat Then listaLinies.Add(w.liniaTicket)
                CollectionViewSource.GetDefaultView(lvTicket.ItemsSource).Refresh()
                CalculaTotals()
            End If
        End If

    End Sub
    Private Sub btnGravar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnGravar.Click

        If txtIdClient.Text <> "" Then

            Dim id As Long
            If Not Long.TryParse(txtId.Text, id) Then id = -1

            Cursor = Cursors.Wait

            Dim ltic As ServeiChiquiPark.LiniaTicket
            Dim i As Integer = 0
            For Each linia As ServeiChiquiPark.LiniaTicket In listaLinies

                If tic.Linies Is Nothing OrElse tic.Linies.Count <> listaLinies.Count Then ReDim tic.Linies(listaLinies.Count - 1)

                ltic = New ServeiChiquiPark.LiniaTicket
                ltic.Id = linia.Id
                ltic.Preu = linia.Preu
                ltic.Quantitat = linia.Quantitat
                ltic.Temps = linia.Temps
                ltic.Article = New ServeiChiquiPark.Article
                ltic.Article.Id = linia.Article.Id
                ltic.Article.Nom = linia.Article.Nom
                ltic.Article.Preu = linia.Article.Preu
                ltic.Article.Imatge = linia.Article.Imatge
                ltic.Article.Tipus = linia.Article.Tipus
                tic.Linies(i) = ltic
                i += 1
            Next

            Try
                If Configuracio.Instance.Servei.SetTicket(tic) Then
                    ResetTextBox()
                Else
                    MsgBox("Error al guardar el ticket !", MsgBoxStyle.Exclamation)
                End If

            Catch ex As Exception
                MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
            End Try

            Cursor = Cursors.Arrow

        Else
            MsgBox("S'ha d'introduïr un client !", MsgBoxStyle.Exclamation)
        End If

    End Sub
    Private Sub btnNou_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnNou.Click

        ResetTextBox()

    End Sub
    Private Sub btnTancar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnTancar.Click

        If Me.Parent IsNot Nothing Then CType(Me.Parent, DockPanel).Visibility = Windows.Visibility.Collapsed

    End Sub
    Private Sub btnEliminar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnEliminar.Click

        If txtId.Text <> "" AndAlso MsgBox("Vol esborrar el ticket ? ", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Dim lng As Long
            If Not Long.TryParse(txtId.Text, lng) Then lng = 0
            If lng > 0 Then
                Try
                    Dim res As Byte = Configuracio.Instance.Servei.DeleteTicket(lng)
                    Select Case res
                        Case 0 : MsgBox("Error al eliminar el ticket !", MsgBoxStyle.Exclamation)
                        Case 1 : ResetTextBox()

                    End Select
                Catch ex As Exception
                    MsgBox("No podem conectar amb el servidor de dades", MsgBoxStyle.Critical)
                End Try
            End If
        End If

    End Sub
#End Region

End Class

'Classe de conversió de dades pel grid String --> Path imatge
Class ObtenerPathImagen
    Implements IValueConverter

    Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert

        If TypeOf value Is String AndAlso value.ToString.Trim <> "" Then
            Try
                Return New Uri(value.ToString)
            Catch ex As Exception
                Return Nothing
            End Try
        Else : Return Nothing
        End If

    End Function

    Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack

        Throw New NotImplementedException()
    End Function

End Class
