﻿Imports System.Data
Imports System.Data.SqlClient

Public Class ChiquiPark
    Implements IChiquiPark

    Private cadenaConexion As String = ""

    Public Sub New()
    End Sub

#Region "Mètodes ADO"

    Private Function ConsultaDades(ByVal nomProcedure As String, parametres As SqlParameter()) As DataSet

        Dim dbConnection As SqlConnection
        Dim ds As New DataSet
        Dim dbDataAdapter As SqlDataAdapter
        Dim cmd As New SqlCommand

        Try
            If cadenaConexion = "" Then cadenaConexion = ConfigurationManager.ConnectionStrings("ChiquiparkConnectionString").ConnectionString
            dbConnection = New SqlConnection(cadenaConexion)
            dbConnection.Open()

            cmd.CommandType = CommandType.StoredProcedure
            cmd.CommandText = nomProcedure
            cmd.Connection = dbConnection
            cmd.Parameters.AddRange(parametres)
            dbDataAdapter = New SqlDataAdapter(cmd)

            Dim commandBuilder As New Data.SqlClient.SqlCommandBuilder(dbDataAdapter)

            dbDataAdapter.Fill(ds)
        Catch e As Exception
            Return Nothing
        End Try

        Return ds

    End Function
    Private Function ExecutarDades(ByVal nomProcedure As String, parametres As SqlParameter()) As Integer

        Dim dbConnection As SqlConnection
        Dim ds As New DataSet
        Dim cmd As New SqlCommand

        Try
            If cadenaConexion = "" Then cadenaConexion = ConfigurationManager.ConnectionStrings("ChiquiparkConnectionString").ConnectionString
            dbConnection = New SqlConnection(cadenaConexion)
            dbConnection.Open()

            cmd.CommandType = CommandType.StoredProcedure
            cmd.CommandText = nomProcedure
            cmd.Connection = dbConnection
            cmd.Parameters.AddRange(parametres)

            cmd.ExecuteNonQuery()

            Dim resultat As Integer = cmd.Parameters("@resultat").Value

            Return resultat

        Catch e As Exception
            Return 0
        End Try


    End Function

#End Region

#Region "Clients"

    Public Function GetClient(ByVal id As Long) As Client Implements IChiquiPark.GetClient

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        ds = ConsultaDades("GetClient", parametres)

        Dim cli As Client = Nothing

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            cli = New Client
            cli.Id = ds.Tables(0).Rows(0)("Id")
            cli.Nom = ds.Tables(0).Rows(0)("Nom").ToString
            cli.Cognoms = ds.Tables(0).Rows(0)("Cognoms").ToString
            cli.Direccio = ds.Tables(0).Rows(0)("Direccio").ToString
            cli.Poblacio = ds.Tables(0).Rows(0)("Poblacio").ToString
            cli.Email = ds.Tables(0).Rows(0)("Email").ToString
            cli.Login = ds.Tables(0).Rows(0)("Login").ToString
            cli.Password = ds.Tables(0).Rows(0)("Password").ToString
        End If

        Return cli

    End Function
    Public Function GetUsuari(ByVal login As String, pwd As String) As Client Implements IChiquiPark.GetUsuari

        Dim cli As Client = Nothing

        If login <> "" AndAlso pwd <> "" Then

            Dim ds As DataSet = Nothing

            Dim parametres As SqlParameter()
            ReDim parametres(1)
            parametres(0) = New SqlParameter("@login", SqlDbType.VarChar)
            parametres(0).Value = login
            parametres(1) = New SqlParameter("@password", SqlDbType.VarChar)
            parametres(1).Value = pwd
            ds = ConsultaDades("GetUsuari", parametres)

            If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
                cli = New Client
                cli.Id = ds.Tables(0).Rows(0)("Id")
                cli.Nom = ds.Tables(0).Rows(0)("Nom").ToString
                cli.Cognoms = ds.Tables(0).Rows(0)("Cognoms").ToString
                cli.Direccio = ds.Tables(0).Rows(0)("Direccio").ToString
                cli.Poblacio = ds.Tables(0).Rows(0)("Poblacio").ToString
                cli.Email = ds.Tables(0).Rows(0)("Email").ToString
                cli.Login = ds.Tables(0).Rows(0)("Login").ToString
                cli.Password = ds.Tables(0).Rows(0)("Password").ToString
            End If
        End If

        Return cli

    End Function
    Public Function GetClients(ByVal filtre As String) As List(Of Client) Implements IChiquiPark.GetClients

        Dim l As New List(Of Client)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(0).Value = filtre
        ds = ConsultaDades("GetClients", parametres)

        Dim cli As Client

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                cli = New Client
                cli.Id = fila("Id")
                cli.Nom = fila("Nom").ToString
                cli.Cognoms = fila("Cognoms").ToString
                cli.Direccio = fila("Direccio").ToString
                cli.Poblacio = fila("Poblacio").ToString
                cli.Email = fila("Email").ToString
                cli.Login = fila("Login").ToString
                cli.Password = fila("Password").ToString

                l.Add(cli)

            Next

        End If

        Return l

    End Function
    Public Function SetClient(ByRef cli As Client) As Byte Implements IChiquiPark.SetClient

        Dim parametres As SqlParameter()
        ReDim parametres(8)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = cli.Id
        parametres(1) = New SqlParameter("@nom", SqlDbType.VarChar)
        parametres(1).Value = cli.Nom
        parametres(2) = New SqlParameter("@cognoms", SqlDbType.VarChar)
        parametres(2).Value = cli.Cognoms
        parametres(3) = New SqlParameter("@direccio", SqlDbType.VarChar)
        parametres(3).Value = cli.Direccio
        parametres(4) = New SqlParameter("@poblacio", SqlDbType.VarChar)
        parametres(4).Value = cli.Poblacio
        parametres(5) = New SqlParameter("@email", SqlDbType.VarChar)
        parametres(5).Value = cli.Email
        parametres(6) = New SqlParameter("@login", SqlDbType.VarChar)
        parametres(6).Value = cli.Login
        parametres(7) = New SqlParameter("@password", SqlDbType.VarChar)
        parametres(7).Value = cli.Password
        parametres(8) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(8).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("SetClient", parametres)

        Return resultat

    End Function
    Public Function DeleteClient(ByVal id As Long) As Byte Implements IChiquiPark.DeleteClient

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        parametres(1) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(1).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("DeleteClient", parametres)

        Return resultat

    End Function

#End Region

#Region "Articles"

    Public Function GetArticle(ByVal id As Long) As Article Implements IChiquiPark.GetArticle

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        ds = ConsultaDades("GetArticle", parametres)

        Dim art As Article = Nothing

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            art = New Article
            art.Id = ds.Tables(0).Rows(0)("Id")
            art.Nom = ds.Tables(0).Rows(0)("Nom").ToString
            art.Preu = ds.Tables(0).Rows(0)("Preu")
            art.Tipus = ds.Tables(0).Rows(0)("Tipus")
            art.Imatge = ds.Tables(0).Rows(0)("Imatge").ToString
        End If

        Return art

    End Function
    Public Function GetArticles(ByVal filtre As String) As List(Of Article) Implements IChiquiPark.GetArticles

        Dim l As New List(Of Article)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(0).Value = filtre
        ds = ConsultaDades("GetArticles", parametres)

        Dim art As Article

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                art = New Article
                art.Id = fila("Id")
                art.Nom = fila("Nom").ToString
                art.Preu = fila("Preu")
                art.Tipus = fila("Tipus")
                art.Imatge = fila("Imatge").ToString

                l.Add(art)

            Next

        End If

        Return l

    End Function
    Public Function GetTipusArticles(ByVal tipus As Boolean, ByVal filtre As String) As List(Of Article) Implements IChiquiPark.GetTipusArticles

        Dim l As New List(Of Article)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@tipus", SqlDbType.Bit)
        parametres(0).Value = tipus
        parametres(1) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(1).Value = filtre
        ds = ConsultaDades("GetTipusArticles", parametres)

        Dim art As Article

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                art = New Article
                art.Id = fila("Id")
                art.Nom = fila("Nom").ToString
                art.Preu = fila("Preu")
                art.Tipus = fila("Tipus")
                art.Imatge = fila("Imatge").ToString

                l.Add(art)

            Next

        End If

        Return l

    End Function
    Public Function SetArticle(ByVal art As Article) As Byte Implements IChiquiPark.SetArticle

        Dim parametres As SqlParameter()
        ReDim parametres(5)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = art.Id
        parametres(1) = New SqlParameter("@nom", SqlDbType.VarChar)
        parametres(1).Value = art.Nom
        parametres(2) = New SqlParameter("@preu", SqlDbType.Money)
        parametres(2).Value = art.Preu
        parametres(3) = New SqlParameter("@tipus", SqlDbType.Bit)
        parametres(3).Value = art.Tipus
        parametres(4) = New SqlParameter("@imatge", SqlDbType.VarChar)
        parametres(4).Value = art.Imatge
        parametres(5) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(5).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("SetArticle", parametres)

        Return resultat

    End Function
    Public Function DeleteArticle(ByVal id As Long) As Byte Implements IChiquiPark.DeleteArticle

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        parametres(1) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(1).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("DeleteArticle", parametres)

        Return resultat

    End Function

#End Region

#Region "Tickets"

    Public Function GetTicket(ByVal id As Long) As Ticket Implements IChiquiPark.GetTicket

        Dim ds As DataSet = Nothing


        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        ds = ConsultaDades("GetTicket", parametres)

        Dim tic As Ticket = Nothing
        Dim ltic As LiniaTicket = Nothing

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then

            tic = New Ticket

            tic.Id = ds.Tables(0).Rows(0)("Id")
            tic.DataTicket = ds.Tables(0).Rows(0)("Data")
            If tic.DataTicket <> Nothing Then
                tic.DataText = tic.DataTicket.ToString("dd/MM/yyyy")
            Else : tic.DataText = ""
            End If
            tic.BaseImponible = ds.Tables(0).Rows(0)("BaseImponible")
            tic.Iva = ds.Tables(0).Rows(0)("Iva")
            tic.Total = ds.Tables(0).Rows(0)("Total")

            tic.Client = GetClient(ds.Tables(0).Rows(0)("Client"))

            For Each fila In ds.Tables(0).Rows

                ltic = New LiniaTicket

                ltic.Id = fila("IdLinia")
                ltic.Quantitat = fila("Quantitat")
                ltic.Preu = fila("Preu")
                ltic.Temps = fila("Temps")

                ltic.Article = GetArticle(fila("Article"))

                tic.Linies.Add(ltic)

            Next


        End If

        Return tic

    End Function
    Public Function GetTickets(ByVal filtre As String) As List(Of Ticket) Implements IChiquiPark.GetTickets

        Dim l As New List(Of Ticket)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(0).Value = filtre
        ds = ConsultaDades("GetTickets", parametres)

        Dim tic As Ticket = Nothing
        Dim ltic As LiniaTicket = Nothing
        Dim idTic As String = ""

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then

            For Each fila In ds.Tables(0).Rows

                If idTic <> fila("IdTicket").ToString Then

                    If tic IsNot Nothing Then l.Add(tic)

                    tic = New Ticket

                    tic.Id = fila("IdTicket")
                    idTic = tic.Id.ToString
                    tic.DataTicket = fila("Data")
                    If tic.DataTicket <> Nothing Then
                        tic.DataText = tic.DataTicket.ToString("dd/MM/yyyy")
                    Else : tic.DataText = ""
                    End If
                    tic.BaseImponible = fila("BaseImponible")
                    tic.Iva = fila("Iva")
                    tic.Total = fila("Total")

                    tic.Client = GetClient(fila("Client"))

                End If

                ltic = New LiniaTicket

                ltic.Id = fila("IdLinia")
                ltic.Quantitat = fila("Quantitat")
                ltic.Preu = fila("Preu")
                ltic.Temps = fila("Temps")

                ltic.Article = GetArticle(fila("Article"))

                tic.Linies.Add(ltic)

            Next

            If tic IsNot Nothing Then l.Add(tic)

        End If

        Return l

    End Function
    Public Function SetTicket(ByVal tic As Ticket) As Byte Implements IChiquiPark.SetTicket

        Dim parametres As SqlParameter()
        ReDim parametres(6)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = tic.Id
        parametres(1) = New SqlParameter("@idCli", SqlDbType.BigInt)
        parametres(1).Value = tic.Client.Id
        parametres(2) = New SqlParameter("@data", SqlDbType.SmallDateTime)
        parametres(2).Value = tic.DataTicket
        parametres(3) = New SqlParameter("@baseImponible", SqlDbType.Money)
        parametres(3).Value = tic.BaseImponible
        parametres(4) = New SqlParameter("@iva", SqlDbType.Money)
        parametres(4).Value = tic.Iva
        parametres(5) = New SqlParameter("@total", SqlDbType.Money)
        parametres(5).Value = tic.Total
        parametres(6) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(6).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("SetTicket", parametres)

        If resultat > 0 Then
            tic.Id = resultat
            ReDim parametres(6)
            For Each linia As LiniaTicket In tic.Linies

                parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
                parametres(0).Value = linia.Id
                parametres(1) = New SqlParameter("@idTic", SqlDbType.BigInt)
                parametres(1).Value = tic.Id
                parametres(2) = New SqlParameter("@idArt", SqlDbType.BigInt)
                parametres(2).Value = linia.Article.Id
                parametres(3) = New SqlParameter("@quantitat", SqlDbType.Int)
                parametres(3).Value = linia.Quantitat
                parametres(4) = New SqlParameter("@preu", SqlDbType.Money)
                parametres(4).Value = linia.Preu
                parametres(5) = New SqlParameter("@temps", SqlDbType.Decimal)
                parametres(5).Value = linia.Temps
                parametres(6) = New SqlParameter("@resultat", SqlDbType.Int)
                parametres(6).Direction = ParameterDirection.ReturnValue

                resultat = ExecutarDades("SetLiniaTicket", parametres)

            Next

        End If

        Return resultat

    End Function
    Public Function DeleteTicket(ByVal id As Long) As Byte Implements IChiquiPark.DeleteTicket

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        parametres(1) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(1).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("DeleteTicket", parametres)

        Return resultat

    End Function

#End Region

#Region "Promocions"

    Public Function GetPromocio(ByVal id As Long) As Promocio Implements IChiquiPark.GetPromocio

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        ds = ConsultaDades("GetPromocio", parametres)

        Dim pro As Promocio = Nothing

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            pro = New Promocio
            pro.Id = ds.Tables(0).Rows(0)("Id")
            pro.Nom = ds.Tables(0).Rows(0)("Nom").ToString
            pro.Descripcio = ds.Tables(0).Rows(0)("Descripcio").ToString
            pro.Article = GetArticle(ds.Tables(0).Rows(0)("Article"))
            pro.Quantitat = ds.Tables(0).Rows(0)("Quantitat")
            pro.Preu = ds.Tables(0).Rows(0)("Preu")
            pro.Temps = ds.Tables(0).Rows(0)("Temps")
        End If

        Return pro

    End Function
    Public Function GetPromocions(ByVal filtre As String) As List(Of Promocio) Implements IChiquiPark.GetPromocions

        Dim l As New List(Of Promocio)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(0).Value = filtre
        ds = ConsultaDades("GetPromocions", parametres)

        Dim pro As Promocio

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                pro = New Promocio
                pro.Id = fila("Id")
                pro.Nom = fila("Nom").ToString
                pro.Descripcio = fila("Descripcio").ToString
                pro.Article = GetArticle(fila("Article"))
                pro.Quantitat = fila("Quantitat")
                pro.Preu = fila("Preu")
                pro.Temps = fila("Temps")

                l.Add(pro)

            Next

        End If

        Return l

    End Function
    Public Function GetArticlePromocions(ByVal idArt As Long, ByVal filtre As String) As List(Of Promocio) Implements IChiquiPark.GetArticlePromocions

        Dim l As New List(Of Promocio)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@idArt", SqlDbType.BigInt)
        parametres(0).Value = idArt
        parametres(1) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(1).Value = filtre
        ds = ConsultaDades("GetArticlePromocions", parametres)

        Dim pro As Promocio

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                pro = New Promocio
                pro.Id = fila("Id")
                pro.Nom = fila("Nom").ToString
                pro.Descripcio = fila("Descripcio").ToString
                pro.Article = GetArticle(fila("Article"))
                pro.Quantitat = fila("Quantitat")
                pro.Preu = fila("Preu")
                pro.Temps = fila("Temps")

                l.Add(pro)

            Next

        End If

        Return l

    End Function
    Public Function SetPromocio(ByVal pro As Promocio) As Byte Implements IChiquiPark.SetPromocio

        Dim parametres As SqlParameter()
        ReDim parametres(7)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = pro.Id
        parametres(1) = New SqlParameter("@nom", SqlDbType.VarChar)
        parametres(1).Value = pro.Nom
        parametres(2) = New SqlParameter("@descripcio", SqlDbType.VarChar)
        parametres(2).Value = pro.Descripcio
        parametres(3) = New SqlParameter("@idArt", SqlDbType.BigInt)
        parametres(3).Value = pro.Article.Id
        parametres(4) = New SqlParameter("@quantitat", SqlDbType.Int)
        parametres(4).Value = pro.Quantitat
        parametres(5) = New SqlParameter("@preu", SqlDbType.Money)
        parametres(5).Value = pro.Preu
        parametres(6) = New SqlParameter("@temps", SqlDbType.Decimal)
        parametres(6).Value = pro.Temps
        parametres(7) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(7).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("SetPromocio", parametres)

        Return resultat

    End Function
    Public Function DeletePromocio(ByVal id As Long) As Byte Implements IChiquiPark.DeletePromocio

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        parametres(1) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(1).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("DeletePromocio", parametres)

        Return resultat

    End Function

#End Region

#Region "Reserves"

    Public Function GetReserva(ByVal id As Long) As Reserva Implements IChiquiPark.GetReserva

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        ds = ConsultaDades("GetReserva", parametres)

        Dim res As Reserva = Nothing

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            res = New Reserva
            res.Id = ds.Tables(0).Rows(0)("Id")
            If ds.Tables(0).Rows(0)("Data") IsNot DBNull.Value Then res.DataReserva = ds.Tables(0).Rows(0)("Data")
            If res.DataReserva <> Nothing Then
                res.DataText = res.DataReserva.ToString("dd/MM/yyyy")
                res.HoraText = res.DataReserva.ToString("hh:mm")
            Else
                res.DataText = ""
                res.HoraText = ""
            End If
            res.Nens = ds.Tables(0).Rows(0)("Nens")
            res.Client = GetClient(ds.Tables(0).Rows(0)("Client"))
            res.Article = GetArticle(ds.Tables(0).Rows(0)("Article"))
        End If

        Return res

    End Function
    Public Function GetReserves(ByVal filtre As String) As List(Of Reserva) Implements IChiquiPark.GetReserves

        Dim l As New List(Of Reserva)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(0)
        parametres(0) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(0).Value = filtre
        ds = ConsultaDades("GetReserves", parametres)

        Dim res As Reserva

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                res = New Reserva
                res.Id = fila("Id")
                If fila("Data") IsNot DBNull.Value Then res.DataReserva = fila("Data")
                If res.DataReserva <> Nothing Then
                    res.DataText = res.DataReserva.ToString("dd/MM/yyyy")
                    res.HoraText = res.DataReserva.ToString("hh:mm")
                Else
                    res.DataText = ""
                    res.HoraText = ""
                End If
                res.Nens = fila("Nens")
                res.Client = GetClient(fila("Client"))
                res.Article = GetArticle(fila("Article"))

                l.Add(res)

            Next

        End If

        Return l

    End Function
    Public Function GetClientReserves(idCli As Long, ByVal filtre As String) As List(Of Reserva) Implements IChiquiPark.GetClientReserves

        Dim l As New List(Of Reserva)

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@idCli", SqlDbType.BigInt)
        parametres(0).Value = idCli
        parametres(1) = New SqlParameter("@filtre", SqlDbType.VarChar)
        parametres(1).Value = filtre
        ds = ConsultaDades("GetClientReserves", parametres)

        Dim res As Reserva

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            For Each fila As DataRow In ds.Tables(0).Rows

                res = New Reserva
                res.Id = fila("Id")
                If fila("Data") IsNot DBNull.Value Then res.DataReserva = fila("Data")
                If res.DataReserva <> Nothing Then
                    res.DataText = res.DataReserva.ToString("dd/MM/yyyy")
                    res.HoraText = res.DataReserva.ToString("hh:mm")
                Else
                    res.DataText = ""
                    res.HoraText = ""
                End If
                res.Nens = fila("Nens")
                res.Client = GetClient(fila("Client"))
                res.Article = GetArticle(fila("Article"))

                l.Add(res)

            Next

        End If

        Return l

    End Function
    Public Function SetReserva(ByVal res As Reserva) As Byte Implements IChiquiPark.SetReserva

        Dim parametres As SqlParameter()
        ReDim parametres(5)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = res.Id
        parametres(1) = New SqlParameter("@data", SqlDbType.DateTime)
        parametres(1).Value = res.DataReserva
        parametres(2) = New SqlParameter("@nens", SqlDbType.SmallInt)
        parametres(2).Value = res.Nens
        parametres(3) = New SqlParameter("@idCli", SqlDbType.BigInt)
        parametres(3).Value = res.Client.Id
        parametres(4) = New SqlParameter("@idArt", SqlDbType.BigInt)
        parametres(4).Value = res.Article.Id
        parametres(5) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(5).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("SetReserva", parametres)

        Return resultat

    End Function
    Public Function DeleteReserva(ByVal id As Long) As Byte Implements IChiquiPark.DeleteReserva

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@id", SqlDbType.BigInt)
        parametres(0).Value = id
        parametres(1) = New SqlParameter("@resultat", SqlDbType.Int)
        parametres(1).Direction = ParameterDirection.ReturnValue

        Dim resultat As Integer = ExecutarDades("DeleteReserva", parametres)

        Return resultat

    End Function
    Public Function GetDiaReserves(ByVal dt As Date, id As Long) As List(Of Reserva) Implements IChiquiPark.GetDiaReserves

        Dim l As New List(Of Reserva)

        Dim i As Integer

        Dim ds As DataSet = Nothing

        Dim parametres As SqlParameter()
        ReDim parametres(1)
        parametres(0) = New SqlParameter("@dataInici", SqlDbType.DateTime)
        parametres(0).Value = dt
        parametres(1) = New SqlParameter("@dataFi", SqlDbType.DateTime)
        parametres(1).Value = dt.AddDays(1)
        ds = ConsultaDades("GetDiaReserves", parametres)

        Dim res As Reserva

        For i = 1 To 7
            res = New Reserva
            res.Id = -1
            res.DataReserva = dt
            Select Case i
                Case 1 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 10, 0, 0)
                Case 2 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 12, 0, 0)
                Case 3 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 14, 0, 0)
                Case 4 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 16, 0, 0)
                Case 5 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 18, 0, 0)
                Case 6 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 20, 0, 0)
                Case 7 : res.DataReserva = New Date(dt.Year, dt.Month, dt.Day, 22, 0, 0)

            End Select
            res.DataText = res.DataReserva.ToString("dd/MM/yyyy")
            res.HoraText = res.DataReserva.ToString("hh:mm")
            res.Nens = 1

            l.Add(res)
        Next

        If ds IsNot Nothing AndAlso ds.Tables.Count > 0 AndAlso ds.Tables(0).Rows.Count > 0 Then
            i = 0
            Dim resAux As Reserva
            Dim dtAux As Date
            Dim listaHoresOcupades As New ArrayList
            For Each fila As DataRow In ds.Tables(0).Rows
                While i < l.Count
                    resAux = l(i)
                    If fila("Data") IsNot DBNull.Value Then
                        dtAux = fila("Data")
                    Else : dtAux = Date.MinValue
                    End If
                    If dtAux <> Date.MinValue Then
                        If resAux.DataReserva.Hour = dtAux.Hour Then
                            If id = fila("Client") Then
                                resAux.Id = fila("Id")
                                resAux.Nens = fila("Nens")
                                resAux.Client = GetClient(fila("Client"))
                                resAux.Article = GetArticle(fila("Article"))
                            Else : listaHoresOcupades.Add(i)
                            End If
                            i += 1
                            Exit While
                        ElseIf resAux.DataReserva.Hour < dtAux.Hour Then
                            i += 1
                        Else
                            Exit While
                        End If
                    Else : i += 1
                    End If
                End While
            Next

            For i = listaHoresOcupades.Count - 1 To 0 Step -1
                l.RemoveAt(listaHoresOcupades(i))
            Next

        End If

        Return l

    End Function

#End Region



End Class
