﻿<ServiceContract()>
Public Interface IChiquiPark

    <OperationContract()>
    Function GetClient(ByVal id As Long) As Client

    <OperationContract()>
    Function GetUsuari(ByVal login As String, ByVal pwd As String) As Client

    <OperationContract()>
    Function GetClients(ByVal filtre As String) As List(Of Client)

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha modificat el client correctament, 2 si hi ha un client amb el mateix login
    <OperationContract()>
    Function SetClient(ByRef cli As Client) As Byte

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha esborrat la reserva correctament, 2 si el client te reserves o tickets assignats
    <OperationContract()>
    Function DeleteClient(ByVal id As Long) As Byte

    <OperationContract()>
    Function GetArticle(ByVal id As Long) As Article

    <OperationContract()>
    Function GetArticles(ByVal filtre As String) As List(Of Article)

    <OperationContract()>
    Function GetTipusArticles(ByVal tipo As Boolean, ByVal filtro As String) As List(Of Article)

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha modificat l'article correctament
    <OperationContract()>
    Function SetArticle(ByVal cli As Article) As Byte

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha esborrat la reserva correctament, 2 si l'article te reserves, 
    'tickets o promocions assignades
    <OperationContract()>
    Function DeleteArticle(ByVal id As Long) As Byte

    <OperationContract()>
    Function GetPromocio(ByVal id As Long) As Promocio

    <OperationContract()>
    Function GetPromocions(ByVal filtre As String) As List(Of Promocio)

    <OperationContract()>
    Function GetArticlePromocions(ByVal id As Long, ByVal filtro As String) As List(Of Promocio)

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha modificat la promoció correctament
    <OperationContract()>
    Function SetPromocio(ByVal pro As Promocio) As Byte

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha esborrat la promoció correctament
    <OperationContract()>
    Function DeletePromocio(ByVal id As Long) As Byte

    <OperationContract()>
    Function GetTicket(ByVal id As Long) As Ticket

    <OperationContract()>
    Function GetTickets(ByVal filtre As String) As List(Of Ticket)
    'hola
    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha modificat el ticket correctament
    <OperationContract()>
    Function SetTicket(ByVal tic As Ticket) As Byte

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha esborrat el ticket correctament
    <OperationContract()>
    Function DeleteTicket(ByVal id As Long) As Byte

    <OperationContract()>
    Function GetReserva(ByVal id As Long) As Reserva

    <OperationContract()>
    Function GetReserves(ByVal filtre As String) As List(Of Reserva)

    <OperationContract()>
    Function GetClientReserves(ByVal id As Long, ByVal filtro As String) As List(Of Reserva)

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha modificat la reserva correctament
    <OperationContract()>
    Function SetReserva(ByVal res As Reserva) As Byte

    'Retorna 0 si no ha pugut connectar amb la Bd, 1 si s'ha esborrat la reserva correctament
    <OperationContract()>
    Function DeleteReserva(ByVal id As Long) As Byte

    <OperationContract()>
    Function GetDiaReserves(data As Date, id As Long) As List(Of Reserva)

End Interface

<DataContract()>
Public Class Client

    <DataMember()>
    Public Property Id() As Long = -1

    <DataMember()>
    Public Property Nom() As String = ""

    <DataMember()>
    Public Property Cognoms() As String = ""

    <DataMember()>
    Public Property Direccio() As String = ""

    <DataMember()>
    Public Property Poblacio() As String = ""

    <DataMember()>
    Public Property Email() As String = ""

    <DataMember()>
    Public Property Login() As String = ""

    <DataMember()>
    Public Property Password() As String = ""

End Class

<DataContract()>
Public Class Article

    <DataMember()>
    Public Property Id() As Long = -1

    <DataMember()>
    Public Property Nom() As String = ""

    <DataMember()>
    Public Property Preu() As Double = 0.0

    <DataMember()>
    Public Property Tipus() As Boolean = False

    <DataMember()>
    Public Property Imatge() As String = ""

End Class

<DataContract()>
Public Class Promocio

    <DataMember()>
    Public Property Id() As Long = -1

    <DataMember()>
    Public Property Nom() As String = ""

    <DataMember()>
    Public Property Descripcio() As String = ""

    <DataMember()>
    Public Property Article() As Article

    <DataMember()>
    Public Property Preu() As Double = 0.0

    <DataMember()>
    Public Property Quantitat() As Double = 0.0

    <DataMember()>
    Public Property Temps() As Double = 0.0

End Class

<DataContract()>
Public Class LiniaTicket

    <DataMember()>
    Public Property Id() As Long = -1

    <DataMember()>
    Public Property Article() As Article

    <DataMember()>
    Public Property Preu() As Double = 0.0

    <DataMember()>
    Public Property Quantitat() As Double = 0.0

    <DataMember()>
    Public Property Temps() As Double = 0.0

End Class

<DataContract()>
Public Class Ticket

    <DataMember()>
    Public Property Id() As Long

    <DataMember()>
    Public Property Client() As Client

    <DataMember()>
    Public Property DataTicket As Date = Today

    <DataMember()>
    Public Property DataText As String = ""

    <DataMember()>
    Public Property BaseImponible() As Double = 0.0

    <DataMember()>
    Public Property Iva() As Double = 0.0

    <DataMember()>
    Public Property Total() As Double = 0.0

    <DataMember()>
    Public Property Linies() As New List(Of LiniaTicket)

End Class

<DataContract()>
Public Class Reserva

    <DataMember()>
    Public Property Id() As Long

    <DataMember()>
    Public Property Client() As Client

    <DataMember()>
    Public Property Article() As Article

    <DataMember()>
    Public Property DataReserva As DateTime = Today

    <DataMember()>
    Public Property DataText As String = ""

    <DataMember()>
    Public Property HoraText As String = ""

    <DataMember()>
    Public Property Nens As Byte = 1

End Class
